/*
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2018-10-10 14:44:45
 * @LastEditors: 无尘
 * @LastEditTime: 2020-03-23 13:40:13
 */
import Vue from 'vue';
// import axios from 'axios';
import qs from 'qs';
import { Message } from 'element-ui';

/**
 * 获取好办 企业 id
 */
// if (!!localStorage.getItem('userInfos')) {
//   let haobanSign = JSON.parse(localStorage.getItem('userInfos')).enterpriseId;
//   Vue.axios.defaults.headers.post['haobansign'] = haobanSign;
//   Vue.axios.defaults.headers.get['haobansign'] = haobanSign;
// }

Vue.axios.defaults.timeout = 500000;
let local = window.location.origin;
/* if (local.indexOf('localhost') != -1) {
  local = 'http://www.gicdev.com';
} */
let axiosPromiseArr = []; //储存cancel toke

Vue.axios.interceptors.request.use(
  config => {
    // 在发送请求设置cancel token
    config.cancelToken = new Vue.axios.CancelToken(cancel => {
      axiosPromiseArr.push({
        cancel
      });
    });
    return config;
  },
  err => {
    Message.error({ message: '请求超时!' });
    return Promise.resolve(err);
  }
);

Vue.axios.interceptors.response.use(
  data => {
    // console.log(data);
    if (data.status && data.status == 200 && data.data.errorCode != 1) {
      // Message.error({message: data.data.message});
      if (data.data.errorCode == 4) {
        if (window.location.href.indexOf('gic-error') != -1) {
          return false;
        }
        window.location.href = local + '/haoban-3/#/login';
      }
      if (data.data.errorCode == 10 || data.data.errorCode == 7) {
        window.location.href = local + '/haoban-3/#/index';
      }
      return data;
    }
    return data;
  },
  err => {
    // console.log(err, typeof err, err.response);
    if (Vue.axios.isCancel(err)) {
      console.log('请求取消');
    }
    if (err.response.status == 502) {
      window.location.href = local + '/haoban-3/#/login';
      Message.error({ message: '服务异常⊙﹏⊙∥' });
    }
    // Message.error({message: err.response.message});
    if (err.response.status == 504 || err.response.status == 404) {
      // window.location.href= local + "/haoban-3/#/login"
      // Message.error({message: '服务异常⊙﹏⊙∥'});
    } else if (err.response.status == 403) {
      // window.location.href= local + "/haoban-3/#/login"
      // Message.error({message: '权限不足,请联系管理员!'});
    } else {
      window.location.href = local + '/haoban-3/#/login';
      Message.error({ message: '登录失效!' });
    }
    return Promise.resolve(err);
  }
);

/*
 *
 * 统一 get 请求方法
 * @url: 请求的 url
 * @params: 请求带的参数
 * @header: 带 token
 *
 */
export const getRequest = (url, params) => {
  params.requestProject = 'haoban-manage-web';
  return Vue.axios({
    method: 'get',
    url: `${local}${url}`,
    data: {},
    params: params,
    headers: {
      'Content-type': 'application/x-www-form-urlencoded'
    } // "token": token
  });
};

/**
 *
 * 统一 post 请求方法
 * url: 请求的 url
 * @params: 请求带的参数
 * @header:
 *
 */
export const postRequest = (url, params) => {
  params.requestProject = 'haoban-manage-web';
  return Vue.axios({
    method: 'post',
    url: `${local}${url}`,
    data: qs.stringify(params),
    headers: {
      'Content-type': 'application/x-www-form-urlencoded'
    } //multipart/form-data{"token": token}
  });
};

export const postJsonRequest = (url, params) => {
  params.requestProject = 'haoban-manage-web';
  return Vue.axios({
    method: 'post',
    url: `${local}${url}`,
    data: '{}',
    params: params,
    headers: { 'Content-Type': 'application/json;charset=UTF-8' } //multipart/form-data{"token": token}
  });
};

/**
 * method: 'post'
 * 'Content-Type': 'application/json;charset=UTF-8'
 * @data: params
 * @requestProject: 'haoban-manage-web'
 *
 */
export const postJson = (url, params) => {
  // params.requestProject = "haoban-manage-web";
  return Vue.axios({
    method: 'post',
    url: `${local}${url}`,
    data: params,
    params: { requestProject: 'haoban-manage-web' },
    // withCredentials: true,
    // credentials: 'same-origin',
    headers: { 'Content-Type': 'application/json;charset=UTF-8' } //multipart/form-data{"token": token}
  });
};

/**
 *  method: 'post'
 *  data: params
 *
 */
export const postForm = (url, params) => {
  params.requestProject = 'haoban-manage-web';
  return Vue.axios({
    method: 'post',
    url: `${local}${url}`,
    data: params,
    headers: {} //'content-type': 'application/x-www-form-urlencoded'multipart/form-data{"token": token}
  });
};

/**
 * post excel
 */

export const postExcel = (url, params) => {
  params.requestProject = 'haoban-manage-web';
  return Vue.axios({
    method: 'post',
    url: `${local}${url}`,
    data: qs.stringify(params),
    responseType: 'blob',
    headers: {
      'content-type': 'application/x-www-form-urlencoded'
    } //multipart/form-data{"token": token}
    /* httpAgent: new http.Agent({
      keepAlive: true
    }),
    httpsAgent: new https.Agent({
      keepAlive: true
    }) */
  });
};
